<template>
  <label>
    {{ t('page.settings.timeZone.label') }}
    <p-Dropdown
      v-model="settings.timeZone"
      class="Timezone"
      :options="timeZones"
      option-label="label"
      option-value="value"
      filter
    >
      <!--suppress HtmlUnknownAttribute -->
      <template #option="slotProps">
        <div class="Settings__TimeZoneOption">
          <span>{{ slotProps.option.label }}</span>
          <span class="Settings__LocalTime">{{
            localeNow(slotProps.option.value)
          }}</span>
        </div>
      </template>
    </p-Dropdown>
  </label>
</template>

<script lang="ts" setup>
import { ListOptions } from '@/types'

import moment from 'moment-timezone'
import { settings } from '@/states'
import { useI18n } from 'vue-i18n'

const t = useI18n().t
const timeZones: ListOptions<string> = []

for (const timeZone of moment.tz.names()) {
  timeZones.push({ label: timeZone, value: timeZone })
}

const localeNow = (tz: string) => moment().tz(tz).format('LLLL')
</script>
